/**
  *  \file client/dlg-receiver.h
  */
#ifndef PCC_V2_CLIENT_DLG_RECEIVER_H
#define PCC_V2_CLIENT_DLG_RECEIVER_H

#include "ui/ui.h"
#include "game/player.h"
#include "cpluslib/sigslot.h"

class WReceiverSelector : public UIWidget {
    GPlayerSet  receivers;
    bool        mdown : 1;
 public:
    WReceiverSelector(int id);
    ~WReceiverSelector();

    void        toggleUniversal();
    void        setUniversal();

    void        setReceivers(GPlayerSet set);
    GPlayerSet  getReceivers() const { return receivers; }

    void        draw(GfxCanvas& can, UpdateInfo& ui);
    void        getLayoutInfo(LayoutInfo& li);
    bool        handleEvent(const UIEvent& event, bool second_pass);

    Signal0  sig_receiver_changed;

    enum StandardDialogResult {
        sdr_Cancel,
        sdr_Revise,
        sdr_Send
    };
    StandardDialogResult doStandardDialog(int num_revisable);
    bool                 doSimpleDialog(string_t title);
};

#endif
