/**
  *  \file io/memstream.h
  */
#ifndef PCC_V2_IO_MEMSTREAM_H
#define PCC_V2_IO_MEMSTREAM_H

#include "io/streams.h"
#include "cpluslib/buffer.h"

class MemoryStream : public Stream {
    Buffer<char>  data;
    std::size_t   pos;
 public:
    MemoryStream();
    MemoryStream(const string_t& s);
    MemoryStream(const Buffer<char>& buf);
    ~MemoryStream();

    const Buffer<char>&  getBuffer() const { return data; }
    void                 swapBuffer(Buffer<char>&);
    string_t             getContentsAsString() const;

    std::size_t  read(char* buffer, std::size_t max);
    std::size_t  write(const char* buffer, std::size_t max);
    int          getCapabilities() const;
    bool         seek(fpos_t pos);
    fpos_t       getSize();
    fpos_t       getPos();
    string_t     getName();
};

#endif
